org.apache.sysds.runtime.compress.utils

## Class Bitmap

- java.lang.Object
- - org.apache.sysds.runtime.compress.utils.ABitmap
  - - org.apache.sysds.runtime.compress.utils.Bitmap

-     public final class Bitmap
      extends ABitmap

  Uncompressed representation of one or more columns in bitmap format.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.sysds.runtime.compress.utils.ABitmap

      `ABitmap.BitmapType`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Bitmap(int numCols, IntArrayList[] offsetsLists, int numZeroGroups, double[] values)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getNumValues()` Obtain number of distinct value groups in the column.
    `ABitmap.BitmapType` | `getType()`
    `double[]` | `getValues()` Get all values without unnecessary allocations and copies.
    `double[]` | `getValues(int ix)` Obtain tuple of column values associated with index.
    `void` | `sortValuesByFrequency()`
    `String` | `toString()`

    - ### Methods inherited from class org.apache.sysds.runtime.compress.utils.ABitmap

      `containsZero, getNumColumns, getNumOffsets, getNumOffsets, getOffsetList, getOffsetsList, getZeroCounts`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Bitmap

          public Bitmap(int numCols,
                        IntArrayList[] offsetsLists,
                        int numZeroGroups,
                        double[] values)

  - ### Method Detail

    - #### getValues

          public double[] getValues()

      Get all values without unnecessary allocations and copies.
      Returns:
        dictionary of value tuples

    - #### getValues

          public double[] getValues(int ix)

      Obtain tuple of column values associated with index.
      Parameters:
        `ix` - index of a particular distinct value
      Returns:
        the tuple of column values associated with the specified index

    - #### getNumValues

          public int getNumValues()

      Description copied from class: `ABitmap`
      Obtain number of distinct value groups in the column. this number is also the number of bitmaps, since there is one bitmap per value
      Specified by:
        `getNumValues` in class `ABitmap`
      Returns:
        number of distinct value groups in the column;

    - #### sortValuesByFrequency

          public void sortValuesByFrequency()

      Specified by:
        `sortValuesByFrequency` in class `ABitmap`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `ABitmap`

    - #### getType

          public ABitmap.BitmapType getType()

      Specified by:
        `getType` in class `ABitmap`

Copyright © 2020 The Apache Software Foundation. All rights reserved.